﻿/*
 * RIO2015_AO.h
 *
 * Created: 2015/8/25 下午 06:27:06
 *  Author: Ying
 */ 


#ifndef RIO2015_AO_H_
#define RIO2015_AO_H_

#define AO_CHANNEL_1            0
#define AO_CHANNEL_2            1

#define AO_RANGE_0_5_V              0 // 0 V to 5 V voltage range (default)
#define AO_RANGE_0_10_V             1 // 0 V to 10 V voltage range
#define AO_RANGE_N5_5_V				2 // -5 V to +5 V voltage range
#define AO_RANGE_N10_10_V			3 // -10 V to 10 V voltage range
#define AO_RANGE_4_20_MA            4 // 4 mA to 20 mA current range
#define AO_RANGE_0_20_MA            5 // 0 mA to 20 mA current range
#define AO_RANGE_0_24_MA            6 // 0 mA to 24 mA current range

#define AO_CHANNEL_DISABLE	0x00
#define AO_CHANNEL_ENABLE	0x01

#define	AO_OK			0x00
#define AO_ERR_TIMEOUT	0x01
#define AO_ERR_ARGUMENT	0x02
#define AO_ERR_OVERRUN	0x03
#define AO_ERR_MODE_FAULT	0x04
#define AO_ERR_OVERRUN_AND_MODE_FAULT	0x05
#define	AO_ERR_ARG_CHENNEL_NO	0x06
#define	AO_ERR_ARG_ENABLE	0x07
#define	AO_ERR_ARG_RANGE	0x08
#define AO_ERR_WAIT_READY_TIMEOUT	0x09
#define AO_ERR_BUS_BUSY		0x0A
#define AO_ERR_INIT_FAULT		0x0B

uint8_t ao_init(void);
uint8_t ao_channel_init(uint8_t enable, uint8_t channel_no, uint8_t range, uint16_t gain, uint16_t offset);
uint8_t ao_channel_set_voltage(uint8_t channel_no, float set_voltage, float *real_voltage);
uint8_t ao_channel_set_current(uint8_t channel_no, float set_current, float *real_current);
uint8_t ao_channel_get_status(void);
uint8_t ao_channel_get_voltage(uint8_t channel_no, uint8_t *range, float *set_voltage, float *real_voltage);
uint8_t ao_channel_get_current(uint8_t channel_no, uint8_t *range, float *set_voltage, float *real_voltage);

#endif /* RIO2015_AO_H_ */